summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Vincent Batts <vbatts@slackware.com>2011-01-04 22:01:16 -0600
committer Robby Workman <rworkman@slackbuilds.org>2011-01-04 22:01:16 -0600
commit3af70c6f6f14ca6922a3978cfe1c06d91a6c74fd (patch)
tree005e843686989c1a6a846346504f4cde6eea6f82
parenta5efbbb18281090df26bebb0ae31bfb5c8371a62 (diff)
downloadtemplates-3af70c6f6f14ca6922a3978cfe1c06d91a6c74fd.tar.gz
templates-3af70c6f6f14ca6922a3978cfe1c06d91a6c74fd.tar.xz
rubygem-template.SlackBuild: Added.
This might not quite be perfect yet, but it's a start.
-rw-r--r--rubygem-template.SlackBuild145
1 files changed, 145 insertions, 0 deletions
diff --git a/rubygem-template.SlackBuild b/rubygem-template.SlackBuild
new file mode 100644
index 0000000..7ec4501
--- /dev/null
+++ b/rubygem-template.SlackBuild
@@ -0,0 +1,145 @@
+#!/bin/sh
+
+# Slackware build script for <appname>
+
+# Written by (your name) (your contact information)
+
+# (add license information here if you desire; otherwise,
+# all submissions are considered to be in the public domain)
+# Some licenses may incorporate the "Written by" information
+# above, and if so, that line can be omitted
+# We strongly suggest *not* using GPL for scripts, as it requires
+# a copy of the GPL to be distributed with it. Since the GPL
+# itself is longer than any build script will be, this just doesn't
+# make good sense...
+
+# |-----------------------------------------------------------------| #
+# REMOVE THIS ENTIRE BLOCK OF TEXT #
+#
+# This template is not meant to be a 'cut and paste' script to
+# enable any random user to make a working package. While
+# we're certainly not discouraging use of this template, if
+# you haven't manually gone through each step of the process
+# without the build script (typically as a normal user, as this
+# will reveal problems that you won't see as root), then there's
+# a good chance that something important is missing from your
+# submission.
+
+# When using this template script, please remove as many of
+# these unnecessary comments as possible. Commented code is
+# a good thing, but if it's obvious, there's no need to comment it.
+#
+# AGAIN, REMOVE THE COMMENTS IF THEY ARE NOT NEEDED - DON'T JUST
+# DELETE THIS BLOCK OF TEXT WITHOUT BOTHERING TO READ WHAT'S IN IT.
+#
+# |-----------------------------------------------------------------| #
+
+PRGNAM=rubygem-appname # replace 'appname' with name of gem
+VERSION=${VERSION:-1.4.1} # replace with version of program
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo} # the "_SBo" is required
+
+SRCNAM=appname # replace with name of gem
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+# Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo} # For consistency's sake, use this
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp} # Drop the package in /tmp
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+
+# Get the full path of the ruby installation, for gems
+DESTDIR=$( ruby -r rbconfig -e '
+include RbConfig
+printf("%s/%s/gems/%s\n",
+ CONFIG["libdir"],
+ CONFIG["RUBY_INSTALL_NAME"],
+ CONFIG["ruby_version"]
+ )
+')
+
+# print a friendly warning of unsatisfied ":runtime" dependencies
+# good to leave in place, even if the gem doesn't have any dependencies.
+# things could always change
+gem specification $CWD/$SRCNAM-$VERSION.gem | \
+ ruby -r yaml -e '
+obj = YAML::load($stdin)
+obj.ivars["dependencies"].each {|d|
+ if not(d.ivars["type"] == :runtime)
+ next
+ end
+
+ name = d.ivars["name"]
+ begin
+ require name
+ rescue LoadError
+ $stderr.write("WARNING: #{name} gem not found\n")
+ sleep 0.5
+ end
+}'
+
+gem install \
+ --local \
+ --no-update-sources \
+ --ignore-dependencies \
+ --backtrace \
+ --install-dir $PKG/$DESTDIR \
+ --bindir $PKG/usr/bin \
+ $CWD/$SRCNAM-$VERSION.gem
+
+# Strip binaries and libraries.
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Remove cached gem from install, if you are so inspired ..
+#rm -rf $PKG/$DESTDIR/cache
+
+# Copy program documentation into the package
+# The included documentation varies from one application to another, so be sure
+# to adjust your script as needed
+# Also, include the SlackBuild script in the documentation directory
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+tar -x -O --file=$CWD/$SRCNAM-$VERSION.gem data.tar.gz | tar -xz -C $PKG/usr/doc/$PRGNAM-$VERSION --file=- \
+ <documentation> \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# Copy the slack-desc (and a custom doinst.sh if necessary) into ./install
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+# Make the package; be sure to leave it in $OUTPUT
+# If package symlinks need to be created during install *before*
+# your custom contents of doinst.sh runs, then add the -p switch to
+# the makepkg command below -- see makepkg(8) for details
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}